﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage;
using Microsoft.EntityFrameworkCore.Storage.Internal;
using repository.Context;
using System;

namespace repository.Migrations
{
    [DbContext(typeof(QuestionariosContext))]
    [Migration("20180407071951_BancoInicial")]
    partial class BancoInicial
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.0.1-rtm-125")
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("domain.Entities.AlternativaDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Alternativa")
                        .IsRequired()
                        .HasMaxLength(400);

                    b.Property<bool>("Correta");

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<int>("IdPergunta");

                    b.HasKey("Id");

                    b.HasIndex("IdPergunta");

                    b.ToTable("Alternativas");
                });

            modelBuilder.Entity("domain.Entities.CategoriaDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<string>("Nome")
                        .IsRequired()
                        .HasMaxLength(50);

                    b.Property<string>("TipoCategoria")
                        .IsRequired()
                        .HasMaxLength(50);

                    b.HasKey("Id");

                    b.ToTable("Categorias");
                });

            modelBuilder.Entity("domain.Entities.PerguntaConfiguracaoDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Campo")
                        .IsRequired()
                        .HasMaxLength(50);

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<int>("IdPergunta");

                    b.Property<string>("TipoValor")
                        .IsRequired()
                        .HasMaxLength(50);

                    b.Property<string>("Valor")
                        .IsRequired()
                        .HasMaxLength(20);

                    b.HasKey("Id");

                    b.HasIndex("IdPergunta");

                    b.ToTable("PerguntasConfiguracoes");
                });

            modelBuilder.Entity("domain.Entities.PerguntaDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("Ativo");

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<int>("IdCategoria");

                    b.Property<int>("IdTipoPergunta");

                    b.Property<int>("IdUsuario");

                    b.Property<bool>("Opcional");

                    b.Property<string>("Pergunta")
                        .IsRequired()
                        .HasMaxLength(1000);

                    b.HasKey("Id");

                    b.HasIndex("IdCategoria");

                    b.HasIndex("IdTipoPergunta");

                    b.HasIndex("IdUsuario");

                    b.ToTable("Perguntas");
                });

            modelBuilder.Entity("domain.Entities.PermissaoDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<string>("Nome")
                        .IsRequired()
                        .HasMaxLength(30);

                    b.HasKey("Id");

                    b.ToTable("Permissoes");
                });

            modelBuilder.Entity("domain.Entities.QuestionarioDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("Ativo");

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<int>("IdCategoria");

                    b.Property<int>("IdUsuario");

                    b.Property<string>("Nome")
                        .IsRequired()
                        .HasMaxLength(100);

                    b.Property<bool>("Privado");

                    b.Property<string>("Senha")
                        .HasMaxLength(10);

                    b.HasKey("Id");

                    b.HasIndex("IdCategoria");

                    b.HasIndex("IdUsuario");

                    b.ToTable("Questionarios");
                });

            modelBuilder.Entity("domain.Entities.QuestionarioPerguntaDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("Ativo");

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<int>("IdPergunta");

                    b.Property<int>("IdQuestionario");

                    b.HasKey("Id");

                    b.HasIndex("IdPergunta");

                    b.HasIndex("IdQuestionario");

                    b.ToTable("QuestionariosPerguntas");
                });

            modelBuilder.Entity("domain.Entities.RespostaDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<int>("IdQuestionarioPergunta");

                    b.Property<string>("Resposta")
                        .IsRequired()
                        .HasMaxLength(1000);

                    b.Property<string>("Sessao")
                        .HasMaxLength(100);

                    b.Property<string>("TipoValor")
                        .IsRequired()
                        .HasMaxLength(100);

                    b.HasKey("Id");

                    b.HasIndex("IdQuestionarioPergunta");

                    b.ToTable("Respostas");
                });

            modelBuilder.Entity("domain.Entities.TipoPerguntaDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<string>("Nome")
                        .IsRequired()
                        .HasMaxLength(100);

                    b.HasKey("Id");

                    b.ToTable("TiposPerguntas");
                });

            modelBuilder.Entity("domain.Entities.UsuarioDomain", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<bool>("Ativo");

                    b.Property<DateTime>("DataCriacao");

                    b.Property<bool>("Deletado");

                    b.Property<string>("Email")
                        .IsRequired()
                        .HasMaxLength(50);

                    b.Property<int>("IdPermissao");

                    b.Property<string>("Nome")
                        .IsRequired()
                        .HasMaxLength(60);

                    b.Property<string>("Senha")
                        .IsRequired()
                        .HasMaxLength(60);

                    b.Property<string>("Usuario")
                        .IsRequired()
                        .HasMaxLength(30);

                    b.HasKey("Id");

                    b.HasIndex("IdPermissao");

                    b.HasIndex("Usuario")
                        .IsUnique()
                        .HasName("Usuario");

                    b.ToTable("Usuarios");
                });

            modelBuilder.Entity("domain.Entities.AlternativaDomain", b =>
                {
                    b.HasOne("domain.Entities.PerguntaDomain", "Pergunta")
                        .WithMany("Alternativas")
                        .HasForeignKey("IdPergunta")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("domain.Entities.PerguntaConfiguracaoDomain", b =>
                {
                    b.HasOne("domain.Entities.PerguntaDomain", "Pergunta")
                        .WithMany("PerguntaConfiguracoes")
                        .HasForeignKey("IdPergunta")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("domain.Entities.PerguntaDomain", b =>
                {
                    b.HasOne("domain.Entities.CategoriaDomain", "Categoria")
                        .WithMany("Perguntas")
                        .HasForeignKey("IdCategoria")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("domain.Entities.TipoPerguntaDomain", "TipoPergunta")
                        .WithMany("Perguntas")
                        .HasForeignKey("IdTipoPergunta")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("domain.Entities.UsuarioDomain", "Usuario")
                        .WithMany("Perguntas")
                        .HasForeignKey("IdUsuario")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("domain.Entities.QuestionarioDomain", b =>
                {
                    b.HasOne("domain.Entities.CategoriaDomain", "Categoria")
                        .WithMany("Questionarios")
                        .HasForeignKey("IdCategoria")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("domain.Entities.UsuarioDomain", "Usuario")
                        .WithMany("Questionarios")
                        .HasForeignKey("IdUsuario")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("domain.Entities.QuestionarioPerguntaDomain", b =>
                {
                    b.HasOne("domain.Entities.PerguntaDomain", "Pergunta")
                        .WithMany("QuestionariosPerguntas")
                        .HasForeignKey("IdPergunta")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("domain.Entities.QuestionarioDomain", "Questionario")
                        .WithMany("QuestionariosPerguntas")
                        .HasForeignKey("IdQuestionario")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("domain.Entities.RespostaDomain", b =>
                {
                    b.HasOne("domain.Entities.QuestionarioPerguntaDomain", "QuestionarioPergunta")
                        .WithMany("Respostas")
                        .HasForeignKey("IdQuestionarioPergunta")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("domain.Entities.UsuarioDomain", b =>
                {
                    b.HasOne("domain.Entities.PermissaoDomain", "Permissao")
                        .WithMany("Usuario")
                        .HasForeignKey("IdPermissao")
                        .OnDelete(DeleteBehavior.Restrict);
                });
#pragma warning restore 612, 618
        }
    }
}
